#include <iostream>
#define int long long
using namespace std;
int v[1000005];
int32_t main()
{
    int n,k;
    cin>>n>>k;
    int mx=0;
    for(int i=1;i<=n;i++){
        cin>>v[i];
        mx=max(mx,v[i]);
    }
    int ans=0;
    for(int val=mx;val>0;val--){
        int sau=0;
        int nr=0;
        for(int i=1;i<=n;i++){
            sau=sau|(v[i]);
            int x=(sau&val);
            if(x==val){
                nr++;
                sau=0;
            }
        }
        if(nr>=k){
            ans=val;
            break;
        }
    }
    cout<<ans;
    return 0;
}
